<% @Language=VBScript %>
<!-- #include file="routines.vbs" -->
<%
    Function CheckExt(s)
        If s = "" Then 
            CheckExt = False
        ElseIf Instr(s,".") > 0 Or InStr(s,":") > 0 Or InStr(s,";") > 0 Then
            CheckExt = False
        Else
            CheckExt = True
        End If
    End Function
    
    Set cfg = Server.CreateObject("newObjects.utilctls.ConfigFile")
    Dim app, defaults
    
    If fileApp = "" Then
        ' Read default
        Set app = cfg.Read(Server.MapPath("/alp.application"))
        fileApp = pathFor & "alp.application"
        dirApp = pathFor
        cfg.Write fileApp,app
    Else
        Set app = cfg.Read(fileApp)
    End If 
    
    Set defaults = cfg.Read(Server.MapPath("defaults.app"))
    
    ' Check consistency
    If Not IsObject(app("APPLICATION")) Then
        app.Add "APPLICATION", cfg.CreateSection
    End If
    If Not IsObject(app("APPLICATION")("InternalExecutionMap")) Then
        app("APPLICATION").Add "InternalExecutionMap", cfg.CreateSection
    End If
    If Not IsObject(app("APPLICATION")("InternalExecutionMap")("File")) Then
        app("APPLICATION")("InternalExecutionMap").Add "File", cfg.CreateSection
    End If    
    
    Set fileMap = app("APPLICATION")("InternalExecutionMap")("File")
    If Not IsObject(fileMap("FileTypes")) Then
        fileMap.Add "FileTypes", cfg.CreateSection
        cfg.Write fileApp, app
    End IF
    Set Mimes = fileMap("FileTypes")
    If Not IsObject(fileMap("ForceDownload")) Then
        fileMap.Add "ForceDownload", cfg.CreateSection
        cfg.Write fileApp, app
    End If
    Set Force = fileMap("ForceDownload")
    
    Dim extName,extMime,extForce
    extName = ""
    extMime = "application/octet-stream"
    extForce = 0
    

    Dim n, message, str, bShowMessageOnly, Module, ext
    message = ""
    bShowMessageOnly = False
    If Request("EditExt").Count > 0 Then
        If Request("EXTS") <> "." Then
            extName = CStr(Request("EXTS"))
            extMime = Mimes(extName)
            If IsEmpty(Force(extName)) Then
                extForce = 0
            Else
                extForce = 1
            End If
        End If
    ElseIf Request("Remove").Count > 0 Then
        Mimes.Remove Request("EXTS")
        Force.Remove Request("EXTS")
        cfg.Write fileApp, app
    ElseIf Request("Update").Count > 0 Then
        str = CStr(Request("EXT"))
        If CheckExt(str) Then
            Mimes(str) = CStr(Request("Mime"))
            If Request("Force").Count > 0 Then
                Force(str) = 1
            Else
                Force.Remove str
            End If
            cfg.Write fileApp, app
        Else
            bShowMessageOnly = True
            message = "Incorrect file extension specified."
        End If
    Else
        bShowMessageOnly = False
    End IF
    
%>
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta http-equiv="Content-Language" content="en-us">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<link REL="stylesheet" HREF="styles.css">
<title>ALP Settings</title>
</head>

<body topmargin="0" leftmargin="0">

<table border="0" width="100%" cellspacing="0">
  <!-- #include file="head.inc" -->
  <tr>
    <td width="100%">
        <H4>Current directory</H4>
        <BLOCKQUOTE>
            <%= pathFor %><BR>
            <A HREF="app.asp?Path=<%= pathFor %>">Back to application settings</A>
        </BLOCKQUOTE>
        <% If bShowMessageOnly Then %>
            <I><B><%= message %></B></I>
        <% Else %>
            <DIV ALIGN="CENTER">
            <FORM METHOD="POST" ACTION="<%= Request.ServerVariables("SCRIPT_NAME") %>">
                <INPUT TYPE="HIDDEN" NAME="Path" VALUE="<%= pathFor %>">
                File extensions:
                <A HREF="javascript: void window.open('help/mime.htm#Edit')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                <BR>
                <SELECT NAME="EXTS" SIZE="10">
                    <% For I = 1 To Mimes.Count %>
                        <% If extName = Mimes.Key(I) Then %>
                            <OPTION SELECTED VALUE="<%= Mimes.Key(I) %>"><%= Mimes.Key(I) %> (<%= Mimes(I) %>)</OPTION>
                        <% Else %>
                            <OPTION VALUE="<%= Mimes.Key(I) %>"><%= Mimes.Key(I) %> (<%= Mimes(I) %>)</OPTION>
                        <% End If %>
                    <% Next %>
                </SELECT><BR>
                <INPUT TYPE="SUBMIT" NAME="EditExt" VALUE="Edit">
                <INPUT TYPE="SUBMIT" NAME="Remove" VALUE="Remove">
                <HR>
                <DIV ALIGN="CENTER">
                    <TABLE>
                        <TR>
                            <TD>File extension
                            <A HREF="javascript: void window.open('help/mime.htm#Ext')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                            </TD>
                            <TD><INPUT TYPE="TEXT" NAME="EXT" VALUE="<%= extName %>"></TD>
                        </TR>
                        <TR>
                            <TD>Mime type
                            <A HREF="javascript: void window.open('help/mime.htm#MimeType')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                            </TD>
                            <TD><INPUT TYPE="TEXT" NAME="Mime" VALUE="<%= extMime %>"></TD>
                        </TR>
                        <TR>
                            <TD>Force download
                            <A HREF="javascript: void window.open('help/mime.htm#Force')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                            </TD>
                            <TD><INPUT TYPE="CHECKBOX" NAME="Force" VALUE="On" <%= Checked(extForce) %>></TD>
                        </TR>
                    </TABLE>
                    <INPUT TYPE="SUBMIT" NAME="Update" VALUE="Add/Update">
                </DIV>
            </FORM>
            </DIV>
        <% End If %>
    </td>
  </tr>
</table>

</body>

</html>
